
#include <math.h>
#include <stdlib.h>
#include "util.h"

extern int  no_inp, no_tar, no_hid, no_wts;
extern real *w, **wi, **wd, **wo, *dw1, *dw2, *s, *hidden, *output;

void createNet()
{
  int i;

  w = (real *) malloc((size_t) no_wts*4*sizeof(real));
  wo = (real **) malloc((size_t) no_tar*sizeof(real*));
  wd = (real **) malloc((size_t) no_tar*sizeof(real*));
  wo[0] = &w[0]; wd[0] = &w[no_hid+1];
  for (i=1; i<no_tar; i++) { wo[i] = wo[i-1]+no_hid+1; wd[i] = wo[i]+no_inp; }
  wi = (real **) malloc((size_t) no_hid*sizeof(real*));
  wi[0] = &w[(no_hid+no_inp+1)*no_tar];
  for (i=1; i<no_hid; i++) wi[i] = wi[i-1]+no_inp+1;
  dw1 = &w[no_wts]; dw2 = &w[no_wts*2]; s = &w[no_wts*3];
  hidden = (real *) malloc((size_t) (no_hid+no_inp+1)*sizeof(real));
  hidden[no_hid] = 1.0;                               /* set the output bias */
  output = (real *) malloc((size_t) no_tar*sizeof(real));
}

void destroyNet()
{
  free(w); free(wi); free(hidden); free(output); free(wo); free(wd);
}

#define NORM cos(6.283185*drand48())*sqrt(-2.0*log(drand48()))

void randomizeNet(real magnitude)
{
  int i;
  
  for (i=0; i<(no_hid+no_inp+1)*no_tar; i++)
    w[i] = magnitude*NORM/sqrt(no_hid+no_inp+1.0);
  for (; i<no_wts; i++)
    w[i] = magnitude*NORM/sqrt(no_inp+1.0);
}
